<template>
  <transition name="fade">
    <div v-if="show" class="modal-feed">
      <div class="modal-feed__top">
        <div class="modal-feed__label">
          Search images <span>Maximum 10 images</span>
        </div>
        <div
          class="modal-feed__close"
          @click="$emit('closeSearchMedia')"
          v-wave
        >
          <svg-icon name="close" />
        </div>
      </div>

      <div class="modal-feed__container">
        <el-checkbox-group
          v-if="media && media.length"
          v-model="search_media"
          :max="10"
        >
          <div class="modal-feed__row">
            <div v-for="item in media" :key="item.id" class="modal-feed__item">
              <div>
                <div
                  class="modal-feed__checkbox"
                  @click="handleCheckedCitiesChange"
                >
                  <el-checkbox :label="item.media_file_id" v-wave>
                    <template
                      v-if="
                        search_media &&
                        search_media.indexOf(item.media_file_id) !== -1
                      "
                    >
                      {{ search_media.indexOf(item.media_file_id) + 1 }}
                    </template>
                    <template v-else>
                      <span></span>
                    </template>
                  </el-checkbox>
                </div>
                <blur-hash-image
                  v-if="item.blurhash"
                  class="blurhash"
                  :hash="item.blurhash"
                  :src="`/storage/${item.preview_url}`"
                />
                <img
                  v-else-if="item.preview_url"
                  :src="`/storage/${item.preview_url}`"
                  alt=""
                />
                <span v-else>loading</span>
              </div>
            </div>
          </div>
        </el-checkbox-group>
      </div>
      <div class="modal-feed__bottom">
        <Button variant="success" @click="submit"> Обновить </Button>
        <div class="modal-feed__upload">
          <el-upload where="portfolio" type="preview" multiple />
        </div>
      </div>
      <!-- <el-upload :onUpload="onUploadPhotoMedia" multiple />
      <Feed :counter="true" :data="media" :moderate="true" /> -->
    </div>
  </transition>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  ref,
  computed
} from '@nuxtjs/composition-api'

import { useUpdateSettingsSearchPhotosMutation } from '~/sdk/hooks'
import { useMediaSubscription } from '~/sdk/hooks'
import { MediaFileFragment, Order_By } from '@/sdk/types'
import elCheckbox from '@/components/element/Checkbox.vue'
import Button from '@/components/ui/Button.vue'
import elUpload from '@/components/element/Upload.vue'

export default defineComponent({
  name: 'SettingPage',
  components: { elCheckbox, elUpload, Button },
  props: ['list', 'show'],
  setup(props, { root }) {
    const { app } = useContext()
    const user = computed(() => root.$accessor.auth.user)

    const media = ref<MediaFileFragment[]>([]) as any
    const { onResult, loading } = useMediaSubscription({
      where: {
        album_id: { _is_null: true },
        event_id: { _is_null: true },
        user_id: { _eq: root.$accessor.auth.userId }
      },
      limit: 10000,
      offset: 0
    })
    onResult(result => {
      if (result?.data?.media_files) {
        // media.value = result.data.media_files
        media.value = result.data.media_files.map(function (item: any) {
          return {
            order: item.users_search_photos.length
              ? item.users_search_photos[0].order
              : null,
            media_file_id: item.id,
            preview_url: item.preview_url,
            blurhash: item.blurhash
          }
        })
      }
    })
    const search_media = ref(
      user.value?.media_search.map(function (item: any) {
        return item.media_file_id
      })
    )

    const handleCheckedCitiesChange = () => {
      // this.checkAll = checkedCount === this.cities.length;
      // if (search_media.value.length >= 10) {
      //   root.$message.warning('Maximum 10 images')
      // }
    }

    // objects: [
    //   {
    //     media_file_id: '5f9ded9b-82ee-41a3-b2fd-6c4b7e399354' as string,
    //     order: 1 as number
    //   }
    // ],

    const { mutate } = useUpdateSettingsSearchPhotosMutation({})
    const submit = async () => {
      if (!search_media.value) return
      const userId = root.$accessor.auth.userId
      try {
        await mutate({
          objects: search_media.value.map(function (item: any, index: any) {
            return { media_file_id: item, order: index + 1 }
          }),
          userId: userId as string
        })
      } catch (e) {
        console.log(e)
      } finally {
        root.$message.success('Search images updated')
      }
    }

    const onUploadPhoto = async (file: File) => {
      try {
        await app.$api.storage.upload(
          `public/web/media/${Date.now()}.jpg`,
          file,
          { type: 'portfolio' }
        )
      } catch (err) {
        root.$message.error('Что-то пошло не так...')
      } finally {
        root.$message.success('Изображения успешно загружены')
      }
    }

    return {
      media,
      submit,
      search_media,
      loading,
      handleCheckedCitiesChange,
      onUploadPhoto
    }
  }
})
</script>

<style lang="scss" scoped>
.modal-feed {
  position: fixed;
  left: 0px;
  right: 0px;
  top: 0px;
  padding: 10px;
  background: #131624;
  z-index: 999;
  display: flex;
  flex-direction: column;
  height: 100vh;
  &__close {
    position: absolute;
    right: 20px;
    top: 50%;
    transform: translateY(-50%);
    width: 45px;
    height: 45px;
    background: #252d45;
    border-radius: 50px;
    z-index: 999;
    display: flex;
    align-items: center;
    justify-content: center;
    box-shadow: -1px 3px 37px rgb(0 0 0 / 15%);
    cursor: pointer;
    @media (min-width: 991.98px) {
      width: 60px;
      height: 60px;
    }
    svg {
      width: 15px;
      height: 15px;
      fill: #00ffb3;
    }
  }
  &__top {
    background-color: #22283a;
    box-shadow: -1px 3px 37px rgb(0 0 0 / 15%);
    padding: 15px 20px 20px 20px;
    position: relative;
    display: flex;
    align-items: center;
    z-index: 99;
    @media (min-width: 991.98px) {
      padding: 20px 25px 25px 25px;
    }
    span {
      display: block;
      color: rgb(133, 145, 173);
      font-size: 14px;
      line-height: 16px;
      @media (min-width: 991.98px) {
        font-size: 16px;
        line-height: 16px;
        margin-top: 5px;
      }
    }
  }
  &__label {
    font-size: 24px;
    line-height: 30px;
    font-weight: 500;
    letter-spacing: 0px;
    color: #00ffb3;
    margin: 0;
    padding: 0;
  }
  &__container {
    background-color: #22283a;
    padding: 0px;
    flex: 1;
    overflow-y: auto;
    overflow-x: hidden;
    position: relative;
    @media (min-width: 991.98px) {
      padding: 25px 25px 0 25px;
    }
  }
  &__bottom {
    padding: 10px;
    background-color: #22283a;
    display: flex;
    align-items: center;
    @media (min-width: 991.98px) {
      padding: 25px;
    }
    > * {
      flex: 1;
      min-height: inherit !important;
    }
  }
  &__row {
    display: flex;
    flex-wrap: wrap;
    margin: -2px;
    @media (min-width: 991.98px) {
      margin: -5px;
    }
  }
  &__item {
    flex: none;
    width: 33.3333%;
    height: 33.3333%;
    position: relative;
    @media (min-width: 768px) {
      width: 20%;
      height: 20%;
    }
    @media (min-width: 1400px) {
      width: 10%;
      height: 10%;
    }
    > div {
      padding: 2px;
      position: relative;
      @media (min-width: 991.98px) {
        padding: 5px;
      }
    }
  }
  &__checkbox {
    position: absolute;
    left: 2px;
    right: 2px;
    top: 2px;
    bottom: 2px;
    display: flex;
    font-size: 0px;
    z-index: 99;
    @media (min-width: 991.98px) {
      left: 5px;
      right: 5px;
      top: 5px;
      bottom: 5px;
    }
    ::v-deep {
      .el-checkbox {
        margin: 0px;
        padding: 0px;
        font-size: 0px;
        display: flex;
        align-items: flex-start;
        justify-content: flex-end;
        flex: 1;
        padding: 10px;
        transition: 850ms all;
        @media (min-width: 991.98px) {
          padding: 15px;
        }
        &.is-checked {
          .el-checkbox__label {
            color: #000;
            background-color: #00ffb3;
          }
        }
        &.is-disabled {
          opacity: 0.5;
          background: #000;
          cursor: not-allowed;
          .el-checkbox__label {
            opacity: 0;
          }
        }
        &__inner {
          display: none;
        }
        &__label {
          width: 28px;
          height: 28px;
          background: #495271;
          border-radius: 50%;
          color: #1c2232;
          font-weight: bold;
          font-size: 14px;
          line-height: 16px;
          display: flex;
          align-items: center;
          justify-content: center;
          transition: 550ms all;
          @media (min-width: 991.98px) {
            width: 35px;
            height: 35px;
            font-size: 18px;
            line-height: 18px;
          }
        }
        &__input {
          &.is-disabled {
            .el-checkbox__inner {
              background-color: #495271;
              border-color: #495271;
              cursor: not-allowed;
            }
          }
          &.is-checked {
            .el-checkbox__label {
              background-color: #00ffb3;
            }
            .el-checkbox__inner {
              background-color: #00ffb3;
            }
          }
        }
      }
    }
  }
  &__upload {
    overflow: hidden;
    flex: 0 0 25%;
    margin-left: 10px;
    @media (min-width: 991.98px) {
      border-radius: 10px;
      margin-left: 20px;
    }
    ::v-deep {
      .upload-image.preview {
        .el-upload-dragger {
          padding-top: 0px;
          padding-bottom: 0px;
          height: 60px;
          justify-content: center;
          @media (min-width: 991.98px) {
            height: 74px;
          }
        }
        .upload-image__title {
          margin-bottom: 0px;
        }
      }
    }
  }
}
</style>
